import java.util.*;
import java.lang.*;
import java.lang.reflect.*;
import java.net.*;
import java.text.*;

import java.applet.Applet;

import java.awt.*;
import java.awt.event.*;
import java.awt.List;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.JList;

public class Page extends Applet
{

    private JButton qButton, iButton, cButton, lcButton;
    private JTextField tf;
    private JTextArea ta;
    private JPanel np;
    private JList lst1, lst2;

    private ActionListener iAL, cAL, qAL, lcAL;

    //Create a button that will display the demo
    public void init()
    {
        setBackground(Color.white);
        setLayout(new BorderLayout());

        qButton = new JButton("Query");
        qButton.setBackground(Color.yellow);
        qAL = new ActionListener()
              {
                  public void actionPerformed(ActionEvent e) {
                      ta.setText("");
                      String s = tf.getText();
                      int j;
                      for(j = 0; j < s.length(); j++)
                      {
                          char c = s.charAt(j);
                          if (c == ' ' || c == '\t' || c == '\n') continue;

                          int a, k = s.length();
                          a = s.indexOf(' ', j);
                          if (a != -1 && a < k) k = a;
                          a = s.indexOf('\t', j);
                          if (a != -1 && a < k) k = a;
                          a = s.indexOf('\n', j);
                          if (a != -1 && a < k) k = a;

                          Query q = new Query (s.substring(j, k), ta, false, 2000);
													q.start();
                          j = k;
                      }
                  }
              };
        qButton.addActionListener(qAL);

        cButton = new JButton("Clear");
        cButton.setBackground(Color.red);
        cAL = new ActionListener()
              {
                  public void actionPerformed (ActionEvent ae)
                  {
                      tf.setText("");
		      ta.setText("");
                  };
              };
        cButton.addActionListener(cAL);

        tf = new JTextField("", 40);
        ta = new JTextArea();
        ta.setEditable(false);
        np = new JPanel();
        np.add(tf);
        np.add(qButton);
        np.add(cButton);
        add(np, BorderLayout.NORTH);
        add(new JScrollPane(ta), BorderLayout.CENTER);

	JLabel s1 = new JLabel("Stratum 1");

        String[] hosts1 = {
				"ntp.alaska.edu",
				"clepsydra.dec.com",
				"clock.isc.org",
				"clock.sgi.com",
				"clock.via.net",
				"gpstime.trimble.com",
				"montpelier.ilan.caltech.edu",
				"nist1.aol-ca.truetime.com",
				"nist1.datum.com",
				"nist1-sj.glassey.com",
				"ntp-cup.external.hp.com",
				"ntp.nasa.gov",
				"tick.gpsclock.com",
				"tick.ucla.edu",
				"timekeeper.isi.edu",
				"tock.gpsclock.com",
				"usno.pa-x.dec.com",
				"navobs1.usnogps.navy.mil",
				"navobs2.usnogps.navy.mil",
				"time-a.nist.gov",
				"time-a.timefreq.bldrdoc.gov",
				"time-b.timefreq.bldrdoc.gov",
				"time-c.timefreq.bldrdoc.gov",
				"time-d.timefreq.bldrdoc.gov",
				"time.nist.gov",
				"utcnist.colorado.edu",
				"ntp2.usno.navy.mil",
				"tick.usno.navy.mil",
				"tock.usno.navy.mil",
				"mizbeaver.udel.edu",
				"ntp1.connectiv.com",
				"ntp1.nss.udel.edu",
				"rackety.udel.edu",
				"ntp-s1.cise.ufl.edu",
				"navobs1.gatech.edu",
				"time.twc.weather.com",
				"tick.mhpcc.edu",
				"ntp0.mcs.anl.gov",
				"truechimer.cso.uiuc.edu",
				"tick.cerias.purdue.edu",
				"tock.cerias.purdue.edu",
				"bonehed.lcs.mit.edu",
				"ntp.quidnet.com",
				"tick.mit.edu",
				"timeserver.cs.umb.edu",
				"time-b.nist.gov",
				"umd1.umd.edu",
				"ntp.colby.edu",
				"navobs1.wustl.edu",
				"ncnoc.ncren.net",
				"terrapin.csc.ncsu.edu",
				"ntp0.jensenresearch.com",
				"nist1-ny.glassey.com",
				"lerc-dns.lerc.nasa.gov",
				"now.okstate.edu",
				"gps1.otc.psu.edu",
				"otc1.psu.edu",
				"wwv.otc.psu.edu",
				"tick.uh.edu",
				"time.xmission.com",
				"nist1.aol-va.truetime.com",
				"nist1-dc.glassey.com",
				"bigben.cac.washington.edu",
				"time-nw.nist.gov",
				"ben.cs.wisc.edu",
				"ntp.ise.canberra.edu.au",
				"ntp0.cs.mu.OZ.AU",
				"ntp1.cs.mu.OZ.AU",
				"ntp1.rnp.br",
				"clock.uregina.ca",
				"subitaneous.cpsc.ucalgary.ca",
				"tick.usask.ca",
				"tock.usask.ca",
				"ntp.metas.ch",
				"swisstime.ethz.ch",
				"ntp.dgf.uchile.cl",
				"ntp.shoa.cl",
				"ntp.cesnet.cz",
				"ntp0.fau.de",
				"ntp1.fau.de",
				"ntp2.fau.de",
				"ntp3.fau.de",
				"ntps1-0.cs.tu-berlin.de",
				"ntps1-1.cs.tu-berlin.de",
				"ptbtime1.ptb.de",
				"ptbtime2.ptb.de",
				"rustime01.rus.uni-stuttgart.de",
				"GPS.FreeBSD.dk",
				"GPS.dix.dk",
				"canon.inria.fr",
				"chronos.cru.fr",
				"ntp-p1.obspm.fr",
				"ntp-sop.inria.fr",
				"ntp1.curie.fr",
				"ntp2.curie.fr",
				"ntp3.curie.fr",
				"clock.cuhk.edu.hk",
				"ntp1.ien.it",
				"ntp2.ien.it",
				"tempo.cstv.to.cnr.it",
				"clock.nc.fukuoka-u.ac.jp",
				"clock.tl.fukuoka-u.ac.jp",
				"cronos.cenam.mx",
				"ntp0.nl.net",
				"ntp1.nl.net",
				"ntp2.nl.net",
				"time.service.uit.no",
				"clock1.canterbury.ac.nz",
				"ntp.certum.pl",
				"vega.cbk.poznan.pl",
				"ntp1.gbg.netnod.se",
				"ntp2.gbg.netnod.se",
				"ntp1.mmo.netnod.se",
				"ntp2.mmo.netnod.se",
				"ntp1.sp.se",
				"ntp2.sp.se",
				"ntp1.sth.netnod.se",
				"ntp2.sth.netnod.se",
				"time1.stupi.se",
				"time2.stupi.se",
				"jamtepat.singnet.com.sg",
				"goodtime.ijs.si",
				"chronos.csr.net",
				"ntp2.ja.net",

				"localhost"
        };
        lst1 = new JList(hosts1);
				lst1.setVisibleRowCount(4);

				JLabel s2 = new JLabel("Stratum 2");

        String[] hosts2 = {
				"sushi.compsci.lyon.edu",
				"decimal.lib.ci.phoenix.az.us",
				"dewey.lib.ci.phoenix.az.us",
				"ntp.drydog.com",
				"clock.fmt.he.net",
				"clock.sjc.he.net",
				"ntp.ucsd.edu",
				"ntp1.mainecoon.com",
				"ntp2.mainecoon.com",
				"ntp1.sf-bay.org",
				"ntp2.sf-bay.org",
				"reloj.kjsl.com",
				"time.berkeley.netdot.net",
				"time.five-ten-sg.com",
				"ntp1.tummy.com",
				"louie.udel.edu",
				"ntp.shorty.com",
				"rolex.usg.edu",
				"timex.usg.edu",
				"chrivh40.cch.com",
				"ntp-0.cso.uiuc.edu",
				"ntp-1.cso.uiuc.edu",
				"ntp-1.mcs.anl.gov",
				"ntp-2.cso.uiuc.edu",
				"ntp-2.mcs.anl.gov",
				"gilbreth.ecn.purdue.edu",
				"harbor.ecn.purdue.edu",
				"horologe.cerias.purdue.edu",
				"molecule.ecn.purdue.edu",
				"tick.cerias.purdue.edu",
				"ntp1.kansas.net",
				"ntp2.kansas.net",
				"ntp.ourconcord.net",
				"ns.nts.umn.edu",
				"nss.nts.umn.edu",
				"time-ext.missouri.edu",
				"chronos1.umt.edu",
				"chronos2.umt.edu",
				"chronos3.umt.edu",
				"clock1.unc.edu",
				"tick.jrc.us",
				"tock.jrc.us",
				"cuckoo.nevada.edu",
				"tick.cs.unlv.edu",
				"tock.cs.unlv.edu",
				"clock.linuxshell.net",
				"clock.nyc.he.net",
				"ntp0.cornell.edu",
				"sundial.columbia.edu",
				"timex.cs.columbia.edu",
				"clock-1.cs.cmu.edu",
				"clock-2.cs.cmu.edu",
				"clock.psu.edu",
				"fuzz.psc.edu",
				"ntp-1.ece.cmu.edu",
				"ntp-2.ece.cmu.edu",
				"ntp.cox.smu.edu",
				"ntp.fnbhs.com",
				"ntp.tmc.edu",
				"ntppub.tamu.edu",
				"tick.greyware.com",
				"tock.greyware.com",
				"ntp-1.vt.edu",
				"ntp-2.vt.edu",
				"ntp.cmr.gov",
				"ntp0.state.vt.us",
				"ntp1.state.vt.us",
				"ntp2.state.vt.us",
				"ntp1.cs.wisc.edu",
				"ntp3.cs.wisc.edu",
				"ntp3.sf-bay.org",
				"time.sinectis.com.ar",
				"tick.nap.com.ar",
				"tock.nap.com.ar",
				"ntp.saard.net",
				"time.deakin.edu.au",
				"ntp1.belbone.be",
				"ntp2.belbone.be",
				"ntp.cais.rnp.br",
				"ntp.hiway.com.br",
				"ntp.pop-pr.rnp.br",
				"ntp.ufes.br",
				"ntp1.pucpr.br",
				"ntp.cpsc.ucalgary.ca",
				"ntp1.cmc.ec.gc.ca",
				"ntp2.cmc.ec.gc.ca",
				"tick.utoronto.ca",
				"time.chu.nrc.ca",
				"time.nrc.ca",
				"timelord.uregina.ca",
				"tock.utoronto.ca",
				"ntp.karpo.cz",
				"ntp1.contactel.cz",
				"ntp2.contactel.cz",
				"clock.netcetera.dk",
				"ntp.mikroskosmos.com",
				"clock2.netcetera.dk",
				"slug.ctv.es",
				"tick.keso.fi",
				"tock.keso.fi",
				"ntp.ndsoftwarenet.com",
				"ntp.obspm.fr",
				"ntp.tuxfamily.net",
				"ntp1.tuxfamily.net",
				"ntp2.tuxfamily.net",
				"ntp.univ-lyon1.fr",
				"ntp.via.ecp.fr",
				"zg1.ntp.carnet.hr",
				"zg2.ntp.carnet.hr",
				"st.ntp.carnet.hr",
				"ri.ntp.carnet.hr",
				"os.ntp.carnet.hr",
				"time.kfki.hu",
				"ntp.incaf.net",
				"ntp.maths.tcd.ie",
				"ntps.net4u.it",
				"ntp.cyber-fleet.net",
				"ntp.ewha.net",
				"time.nuri.net[203.255.112.4]",
				"ntp2a.audiotel.com.mx",
				"ntp2b.audiotel.com.mx",
				"ntp2c.audiotel.com.mx",
				"ntp.doubleukay.com",
				"ntp.supernet300.com",
				"ntp1.theinternetone.net",
				"ntp2.theinternetone.net",
				"ntp3.theinternetone.net",
				"fartein.ifi.uio.no",
				"time.alcanet.no",
				"ntp.iprolink.co.nz",
				"ntp.massey.ac.nz",
				"ntp.public.otago.ac.nz",
				"tk1.ihug.co.nz,",
				"info.cyf-kr.edu.pl:",
				"bug.fe.up.pt",
				"ntp.ip.ro",
				"ntp.psn.ru",
				"sign.chg.ru",
				"ntp.lth.se",
				"ntp.shim.org",
				"biofiz.mf.uni-lj.si",
				"ntp1.arnes.si",
				"ntp2.arnes.si",
				"time.ijs.si",
				"time.ijs.si",
				"clock.cimat.ues.edu.sv",
				"ntp.terabyte.com.ua",
				"bear.zoo.bt.co.uk",
				"ntp.cis.strath.ac.uk",
				"ntp.exnet.com",
				"ntp2a.mcc.ac.uk",
				"ntp2b.mcc.ac.uk",
				"ntp2c.mcc.ac.uk",
				"ntp2d.mcc.ac.uk",
				"ntp0.sandvika.net",
				"ntp1.sandvika.net",
				"ntp2.sandvika.net",
				"ntp0.uk.uu.net",
				"ntp1.uk.uu.net",
				"ntp2.uk.uu.net",
				"tick.tanac.net",
				"time-server.ndo.com",
				"ntp.linux.org.ve",
				"ntp.cs.unp.ac.za",
				"tock.nml.csir.co.za",

				"localhost"
        };
        lst2 = new JList(hosts2);
				lst2.setVisibleRowCount(4);

        iButton = new JButton("Insert");
        iAL = new ActionListener()
              {
                  public void actionPerformed (ActionEvent ae)
                  {
                      String app = "";
                      Object[] items;
		      items = lst1.getSelectedValues();
                      for (int i = 0; i < Array.getLength(items); i++)
                          app += " " + items[i];
		      items = lst2.getSelectedValues();
                      for (int i = 0; i < Array.getLength(items); i++)
                          app += " " + items[i];
                      tf.setText(tf.getText() + app); // + Array.getLength(items));
                  };
              };
        iButton.addActionListener(iAL);

        lcButton = new JButton("Clear selection");
        lcAL = new ActionListener()
              {
                  public void actionPerformed (ActionEvent ae)
                  {
                      lst1.clearSelection();
                      lst2.clearSelection();
                  };
              };
        lcButton.addActionListener(lcAL);

        JPanel sp = new JPanel();
        sp.add(s1);
        sp.add(new JScrollPane(lst1));
        sp.add(s2);
        sp.add(new JScrollPane(lst2));
				Box jb2 = new Box(BoxLayout.Y_AXIS);
        jb2.add(iButton);
        jb2.add(lcButton);
				sp.add(jb2);
        add(new JScrollPane(sp), BorderLayout.SOUTH);
    }
}
